%{
/*
   The lestes compiler suite
   Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
   Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
   Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
   Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
   Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
   Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
   Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   See the full text of the GNU General Public License version 2, and
   the limitations in the file doc/LICENSE.

   By accepting the license the licensee waives any and all claims
   against the copyright holder(s) related in whole or in part to the
   work, its use, and/or the inability to use it.
 
 */
/*! \file pp_lex_guts.yy.cc
  \brief C++ preprocessor lexical analyser.

  Performs lexical analysis of incoming text, forming preprocessor tokens.
  Should only be called by pp_lex objects, which ensure proper connection.
  
  Because flex can only handle 7 bit input, ucn tokens are stored outside
  in an synchronized buffer and flex processes only the corresponding 
  character classes: end of file, translated ucn and each basic source character
  is represented in its own class. Basic source characters character classes
  values are encoded in ASCII, independently on the character set flex
  operates in.

  \author pt
*/

/* GENERAL WARNING:

   The manner in which this file is structured is _VERY_ important, it relies
   on the implicit precedence of certain lexical rules:
   1) longer match is caught every time (no need to worry about order of + and += rules)
   2) in case of tie (i.e. two rules would match the longest portion),
   the first in the source file applies: `bitand' is AMP and not ordinary IDENT (identifier)

   The error-catching rules are set up so that every possible silly input is
   covered and there should be no holes handled by implicit (print) rules
   so be careful when modifying the patterns & stuff.

   Call to yyless() changes yyleng immediately, so store your yyleng into local variable.
   The sequence yless(yyleng - 1); SKIP(yyleng - 1); does NOT work properly!

   This file is injected into its own namespace pp_lex in the file pp_lex.cc and that
   is also the reason it MUST NOT contain any #included files, as these would
   come into invalid namespaces.
*/

#if __GNUC__ > 3
//! avoiding standard C input and output
#pragma GCC poison fprintf fwrite getc fread ferror
#endif

//! avoiding implicit rules
#define ECHO lassert2(false, "ECHO should not be used.")


using namespace ::lestes::std;
using namespace ::lestes::lang::cplus::lex;
using namespace ::std;

//! Current wrapper class, which will be live when used.
static pp_lex *current_ppl;

//! Current ucn token buffer, which will be live when used
static ucn_token_buffer *current_utb;

//! Handles encountering real EOF, which should not happen, formal definition.
#define yyterminate() return pp_token::create(LOCGET,pp_token::TOK_FILE_END)

lstring escape_nonprintable(const lstring &inp)
{
   ::std::stringbuf sb;
   ::std::ostream os(&sb);
   
   for (lstring::const_iterator it = inp.begin(), end = inp.end(); it != end; ++it) {
      char c = *it;
      if (isprint(c)) 
         os << c;
      else
         os << "\\x" << ::std::hex << ::std::setfill('0') << ::std::setw(2) << (ulint)c;
   }
   return sb.str();
}

//! Defines action triggered for each rule.
#define YY_USER_ACTION \
{ \
	/* avoid the warning: address requested for `yy_act', which is declared `register' */ \
	int copy_yy_act = yy_act ; \
	pp_lex_guts_logger << "Rule #" << copy_yy_act << " matched `" << escape_nonprintable(yytext) << "'\n" << msg::eolog; \
}

//! Defines flex input function.
#define YY_INPUT(buf,result,max_size) \
{ \
	result = current_ppl->yy_input(buf,max_size); \
}

//! Defines prototype for flex parser function.
#define YY_DECL ptr<pp_token> lexer_parse(bool line_start)

//! Skips all tokens comprising the current rule.
#define ADVANCE      current_utb->advance(yyleng)
//! Skips supplied count of tokens.
#define SKIP(num)    current_utb->advance(num)
//! Returns next token from buffer
#define PEEK         current_utb->peek_front()
//! Saves location of the next token in buffer.
#define LOCSAVE      current_ppl->location_save()
//! Returns the saved location.
#define LOCGET       current_ppl->location_create()
//! Extracts ordinary sequence until stop character from buffer.
#define EXTRACT_UNTIL(stop) current_utb->extract_until(stop)
//! Extracts ordinary sequence of length len from buffer.
#define EXTRACT_ORDINARY(len) current_utb->extract_ordinary(len)
//! Extracts identifier with ucn of length len from buffer.
#define EXTRACT_UCN_IDENTIFIER(len) current_utb->extract_simple_ucn(len,true)
//! Extracts number with ucn of length len from buffer.
#define EXTRACT_UCN_NUMBER(len) current_utb->extract_simple_ucn(len,false)
//! Extracts identifier with bad ucn of length len from buffer.
#define EXTRACT_BAD_IDENTIFIER(len) current_utb->extract_invalid_ucn(len,true)
//! Extracts number with bad ucn of length len from buffer.
#define EXTRACT_BAD_NUMBER(len) current_utb->extract_invalid_ucn(len,false)
//! Extracts literal of length len from buffer.
#define EXTRACT_UCN_LITERAL(len) current_utb->extract_ucn_literal(len)
//! Extracts literal with invalid escape sequences of length len from buffer.
#define EXTRACT_BAD_LITERAL(len) current_utb->extract_bad_literal(len)

/*!
  Returns one token from flex parser.
  \param read_include  Set to true if reading tokens after #include.
  \return  The next token in input.
*/
YY_DECL;
%}

/* settings for better performance from the knowledge of used and unused features */
/*%option never-interactive*/
%option always-interactive
%option noyywrap
%option nostack
%option noyylineno
%option noinput
%option nounput
%option noyy_push_state
%option noyy_pop_state
%option noyy_top_state
%option noyy_scan_buffer
%option noyy_scan_bytes
%option noyy_scan_string

/* basic source character set character classes */
TAB            "\x09"
VTAB           "\x0b"
FORM_FEED      "\x0c"
NEW_LINE       "\x0a"
SPACE          "\x20"
EMARK          "\x21"
DQUOTE         "\x22"
HASH           "\x23"
PERCENT        "\x25"
AMP            "\x26"
QUOTE          "\x27"
LEFT_PAR       "\x28"
RIGHT_PAR      "\x29"
STAR           "\x2a"
PLUS           "\x2b"
COMMA          "\x2c"
MINUS          "\x2d"
DOT            "\x2e"
SLASH          "\x2f"
D0             "\x30"
D1             "\x31"
D2             "\x32"
D3             "\x33"
D4             "\x34"
D5             "\x35"
D6             "\x36"
D7             "\x37"
D8             "\x38"
D9             "\x39"
COLON          "\x3a"
SEMICOLON      "\x3b"
LT             "\x3c"
EQ             "\x3d"
GT             "\x3e"
QMARK          "\x3f"
A              "\x41"
B              "\x42"
C              "\x43"
D              "\x44"
E              "\x45"
F              "\x46"
G              "\x47"
H              "\x48"
I              "\x49"
J              "\x4a"
K              "\x4b"
L              "\x4c"
M              "\x4d"
N              "\x4e"
O              "\x4f"
P              "\x50"
Q              "\x51"
R              "\x52"
S              "\x53"
T              "\x54"
U              "\x55"
V              "\x56"
W              "\x57"
X              "\x58"
Y              "\x59"
Z              "\x5a"
LEFT_BRACKET   "\x5b"
BACKSLASH      "\x5c"
RIGHT_BRACKET  "\x5d"
HAT            "\x5e"
_              "\x5f"
a              "\x61"
b              "\x62"
c              "\x63"
d              "\x64"
e              "\x65"
f              "\x66"
g              "\x67"
h              "\x68"
i              "\x69"
j              "\x6a"
k              "\x6b"
l              "\x6c"
m              "\x6d"
n              "\x6e"
o              "\x6f"
p              "\x70"
q              "\x71"
r              "\x72"
s              "\x73"
t              "\x74"
u              "\x75"
v              "\x76"
w              "\x77"
x              "\x78"
y              "\x79"
z              "\x7a"
LEFT_BRACE     "\x7b"
VBAR           "\x7c"
RIGHT_BRACE    "\x7d"
TILDE          "\x7e"

/* end of file character class */
EOF            "\x00"
/* translated characters character class */
TRANSLATED     "\x01"

/* helper character classes and sequences */

/* any character */
ANY_CHAR    .|"\n"
/* any character except end of file */
NOT_EOF                 [^\x00]
/* any character except end of line */
NOT_NL                  [^\x0a]
/* any character except star and end of file */
NOT_STAR_EOF            [^\x2a\x00]
/* any character except star, slash and end of file */
NOT_STAR_SLASH_EOF      [^\x2a\x2f\x00]
/* any character except quote, backslash and end of line */
NOT_QUOTE_BACKSLASH_NL  [^\x27\x5c\x0a]
/* any character except double quote, backslash and end of line */
NOT_DQUOTE_BACKSLASH_NL [^\x22\x5c\x0a]
/* any character except greater than and end of line */
NOT_GT_NL               [^\x3e\x0a]
/* any character except double quote and end of line */
NOT_DQUOTE_NL           [^\x22\x0a]

/* decimal digits */ 
DIGIT       {D0}|{D1}|{D2}|{D3}|{D4}|{D5}|{D6}|{D7}|{D8}|{D9}
/* octal digits */ 
OCT_DIGIT   {D0}|{D1}|{D2}|{D3}|{D4}|{D5}|{D6}|{D7}
/* hexadecimal letters */ 
HEX_LETTER  {a}|{b}|{c}|{d}|{e}|{f}|{A}|{B}|{C}|{D}|{E}|{F}
/* hexadecimal digits */ 
HEX_DIGIT   {DIGIT}|{HEX_LETTER}
/* four hexadecimal digits */ 
HEX_QUAD    {HEX_DIGIT}{4}
/* short form of ucn escape sequence */ 
UCN_SHORT   {BACKSLASH}{u}{HEX_QUAD}
/* long form of ucn escape sequence */ 
UCN_LONG    {BACKSLASH}{U}{HEX_QUAD}{2}
/* ucn escape sequence */ 
UCN_ESCAPE  {UCN_SHORT}|{UCN_LONG}
/* ucn bad escape sequence */ 
UCN_BAD     ({BACKSLASH}{u}{HEX_DIGIT}{0,3})|({BACKSLASH}{U}{HEX_DIGIT}{0,7})
/* translated or escaped ucn */ 
UCN         {TRANSLATED}|{UCN_ESCAPE}

/* lower alphabet letters */
LOWER       {a}|{b}|{c}|{d}|{e}|{f}|{g}|{h}|{i}|{j}|{k}|{l}|{m}|{n}|{o}|{p}|{q}|{r}|{s}|{t}|{u}|{v}|{w}|{x}|{y}|{z}
/* lower alphabet letters */
UPPER       {A}|{B}|{C}|{D}|{E}|{F}|{G}|{H}|{I}|{J}|{K}|{L}|{M}|{N}|{O}|{P}|{Q}|{R}|{S}|{T}|{U}|{V}|{W}|{X}|{Y}|{Z}
/* alphabet letters */
ALPHA       {LOWER}|{UPPER}
/* alphanumeric characters */
ALNUM       {ALPHA}|{DIGIT}
/* characters at the start of an identifier */
NONDIGIT    {ALPHA}|{UCN}|{_}
/* blank characters */
BLANK       {SPACE}|{TAB}|{VTAB}|{FORM_FEED}
/* string and character literal escape sequence characters */
ESC_CHAR    {QUOTE}|{DQUOTE}|{QMARK}|{BACKSLASH}|{a}|{b}|{f}|{n}|{r}|{t}|{v}
/* string or character literal escape sequence */
ESCAPE      {BACKSLASH}({ESC_CHAR}|{x}{HEX_DIGIT}+|{OCT_DIGIT}{1,3})
/* content of a line comment */
LINE_COMMENT_CONTENT {NOT_NL}*
/* a line comment */
LINE_COMMENT {SLASH}{SLASH}{LINE_COMMENT_CONTENT}{NEW_LINE}
/* content of a multiline comment */
LONG_COMMENT_CONTENT ({NOT_STAR_EOF}+|{STAR}+{NOT_STAR_SLASH_EOF})*
/* a multiline comment */
LONG_COMMENT {SLASH}{STAR}{LONG_COMMENT_CONTENT}{STAR}+{SLASH}

/* begin conditions */
%x include
%x line
%x directive
%x directive_name

%%

   if (line_start)
      BEGIN(directive);

{LINE_COMMENT} {
   pp_lex_guts_logger << "line comment\n" << msg::eolog;
   
   LOCSAVE;
   /* leave newline in buffer */
	ulint len = yyleng - 1;
	yyless(len);
	SKIP(len);
	return pp_token::create(LOCGET,pp_token::TOK_BLANK);
}

{LONG_COMMENT} {
   pp_lex_guts_logger << "long comment\n" << msg::eolog;

   LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BLANK);
}

{SLASH}{STAR}{LONG_COMMENT_CONTENT}{STAR}*{EOF} {
   pp_lex_guts_logger << "unterminated long comment\n" << msg::eolog;

   LOCSAVE;

   /* leave the implicit new line and EOF in buffer */
	ulint len = yyleng - 2;
   yyless(len);
	SKIP(len);

   ptr<source_location> loc = LOCGET;
	
   /* error: eof within comment == unterminated comment */
	report << unterminated_comment << loc;

	return pp_token::create(loc,pp_token::TOK_BLANK);
}

	/* character literal without ucn escape sequences */
{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{ESCAPE})+{QUOTE} {
   pp_lex_guts_logger << "character literal without escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning quote */
	SKIP(1);
	ptr<token_value> tv(EXTRACT_ORDINARY(yyleng - 2));
   /* the ending quote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_CHAR_LIT,tv);
}

	/* wide character literal without ucn escape sequences */
{L}{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{ESCAPE})+{QUOTE} {
   pp_lex_guts_logger << "wide character literal without escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning L and quote */
	SKIP(2);
	ptr<token_value> tv(EXTRACT_ORDINARY(yyleng - 3));
   /* the ending quote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_WCHAR_LIT,tv);
}

	/* character literal with ucn escape sequences */
{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{UCN_ESCAPE}|{ESCAPE})+{QUOTE} {
   pp_lex_guts_logger << "character literal with escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning quote */
	SKIP(1);
	ptr<token_value> tv(EXTRACT_UCN_LITERAL(yyleng - 2));
   /* the ending quote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_CHAR_LIT,tv);
}

	/* wide character literal with ucn escape sequences */
{L}{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{UCN_ESCAPE}|{ESCAPE})+{QUOTE} {
   pp_lex_guts_logger << "wide character literal with escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning L and quote */
	SKIP(2);
	ptr<token_value> tv(EXTRACT_UCN_LITERAL(yyleng - 3));
   /* the ending quote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_WCHAR_LIT,tv);
}

	/* empty, malformed or unterminated character literal */
{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{BACKSLASH}{ANY_CHAR})*{ANY_CHAR} {
   pp_lex_guts_logger << "character literal with errors\n" << msg::eolog;

   LOCSAVE;

   ptr<source_location> loc = LOCGET;
   
   bool empty = false;
   /* the beginning quote */
	SKIP(1);
	ptr<token_value> tv;
   if (yyleng == 2) {
      /* empty character literal */
      report << empty_character_constant << loc;
      empty = true;
   } else {
      tv = EXTRACT_BAD_LITERAL(yyleng - 2);
      empty = tv->content_get().size() == 0;
   }
   
   if (empty) {
      /* make nonempty character literal */
      tv = token_value::create("\\0");
   }

   ptr<ucn_token> ut = PEEK;
   /* check ending quote */
   if (ut->type_get() == ucn_token::TOK_BASIC &&
         ut->value_get() == character::ascii_quote) {
      /* skip the quote */
	   SKIP(1);
   } else {
      /* return the last character */
      yyless(yyleng - 1);
      /* missing terminating ' character */
      report << missing_terminating_quote << loc;
   }

	return pp_token::create(loc,pp_token::TOK_CHAR_LIT,tv);
}

	/* empty, malformed or unterminated wide character literal */
{L}{QUOTE}({NOT_QUOTE_BACKSLASH_NL}|{BACKSLASH}{ANY_CHAR})*{ANY_CHAR} {
   pp_lex_guts_logger << "wide character literal with errors\n" << msg::eolog;

   LOCSAVE;
   ptr<source_location> loc = LOCGET;

   bool empty = false;
   /* the beginning L and quote */
	SKIP(2);
	ptr<token_value> tv;
   if (yyleng == 3) {
      /* empty character constant */
      report << empty_character_constant << loc;
      empty = true;
   } else {
      tv = EXTRACT_BAD_LITERAL(yyleng - 3);
      empty = tv->content_get().size() == 0;
   }
   
   if (empty) {
      /* make nonempty wide character literal */
      tv = token_value::create("\\0");
   }

   ptr<ucn_token> ut = PEEK;
   /* check ending quote */
   if (ut->type_get() == ucn_token::TOK_BASIC &&
         ut->value_get() == character::ascii_quote) {
      /* skip the quote */
	   SKIP(1);
   } else {
      /* return the last character */
      yyless(yyleng - 1);
      /* missing terminating ' character */
      report << missing_terminating_quote << loc;
   }

	return pp_token::create(LOCGET,pp_token::TOK_WCHAR_LIT,tv);
}

	/* string literal without ucn escape sequences */
{DQUOTE}({NOT_DQUOTE_BACKSLASH_NL}|{ESCAPE})*{DQUOTE} {
   pp_lex_guts_logger << "string literal without escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning dquote */
	SKIP(1);
	ptr<token_value> tv(EXTRACT_ORDINARY(yyleng - 2));
   /* the ending dquote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_STRING_LIT,tv);
}

	/* wide string literal without ucn escape sequences */
{L}{DQUOTE}({NOT_QUOTE_BACKSLASH_NL}|{ESCAPE})*{DQUOTE} {
   pp_lex_guts_logger << "wide string literal without escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning L and dquote */
	SKIP(2);
	ptr<token_value> tv(EXTRACT_ORDINARY(yyleng - 3));
   /* the ending dquote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_WSTRING_LIT,tv);
}

	/* string literal with ucn escape sequences */
{DQUOTE}({NOT_DQUOTE_BACKSLASH_NL}|{UCN_ESCAPE}|{ESCAPE})*{DQUOTE} {
   pp_lex_guts_logger << "string literal with escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning dquote */
	SKIP(1);
	ptr<token_value> tv(EXTRACT_UCN_LITERAL(yyleng - 2));
   /* the ending dquote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_STRING_LIT,tv);
}

	/* wide string literal with ucn escape sequences */
{L}{DQUOTE}({NOT_DQUOTE_BACKSLASH_NL}|{UCN_ESCAPE}|{ESCAPE})*{DQUOTE} {
   pp_lex_guts_logger << "wide string literal with escaped ucn\n" << msg::eolog;

   LOCSAVE;
   /* the beginning L and dquote */
	SKIP(2);
	ptr<token_value> tv(EXTRACT_UCN_LITERAL(yyleng - 3));
   /* the ending dquote */
	SKIP(1);
	return pp_token::create(LOCGET,pp_token::TOK_WSTRING_LIT,tv);
}

	/* malformed or unterminated string literal */
{DQUOTE}({NOT_DQUOTE_BACKSLASH_NL}|{BACKSLASH}{ANY_CHAR})*{ANY_CHAR} {
   pp_lex_guts_logger << "wide string literal with errors\n" << msg::eolog;

   LOCSAVE;
   ptr<source_location> loc = LOCGET;

   /* the beginning dquote */
	SKIP(1);
	ptr<token_value> tv(EXTRACT_BAD_LITERAL(yyleng - 2));

   ptr<ucn_token> ut = PEEK;
   /* check ending dquote */
   if (ut->type_get() == ucn_token::TOK_BASIC &&
         ut->value_get() == character::ascii_dquote) {
      /* skip the dquote */
	   SKIP(1);
   } else {
      /* return the last character */
      yyless(yyleng - 1);
      /* missing terminating " character */
      report << missing_terminating_dquote << loc;
   }

	return pp_token::create(loc,pp_token::TOK_STRING_LIT,tv);
}

	/* malformed or unterminated wide string literal */
{L}{DQUOTE}({NOT_DQUOTE_BACKSLASH_NL}|{BACKSLASH}{ANY_CHAR})*{ANY_CHAR} {
   pp_lex_guts_logger << "wide string literal with errors\n" << msg::eolog;

   LOCSAVE;
   ptr<source_location> loc = LOCGET;
   
   /* the beginning L and dquote */
	SKIP(2);
	ptr<token_value> tv(EXTRACT_BAD_LITERAL(yyleng - 3));

   ptr<ucn_token> ut = PEEK;
   /* check ending dquote */
   if (ut->type_get() == ucn_token::TOK_BASIC &&
         ut->value_get() == character::ascii_dquote) {
      /* skip the dquote */
	   SKIP(1);
   } else {
      /* return the last character */
      yyless(yyleng - 1);
      /* missing terminating " character */
      report << missing_terminating_dquote << loc;
   }

	return pp_token::create(loc,pp_token::TOK_WSTRING_LIT,tv);
}

{BLANK}+ {
   pp_lex_guts_logger << "blanks\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BLANK);
}

{NEW_LINE} {
   pp_lex_guts_logger << "new line\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LINE_END);
}

{LEFT_BRACKET} {
	pp_lex_guts_logger << "left_bracket\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LEFT_BRACKET);
}

{LT}{COLON} {
	pp_lex_guts_logger << "left_bracket\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_LEFT_BRACKET);
}

{RIGHT_BRACKET} {
	pp_lex_guts_logger << "right_bracket\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_RIGHT_BRACKET);
}

{COLON}{GT} {
	pp_lex_guts_logger << "right_bracket\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_RIGHT_BRACKET);
}

{LEFT_BRACE} {
	pp_lex_guts_logger << "left_brace\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LEFT_BRACE);
}

{LT}{PERCENT} {
	pp_lex_guts_logger << "left_brace\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_LEFT_BRACE);
}

{RIGHT_BRACE} {
	pp_lex_guts_logger << "right_brace\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_RIGHT_BRACE);
}

{PERCENT}{GT} {
	pp_lex_guts_logger << "right_brace\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_RIGHT_BRACE);
}

{HASH} {
	pp_lex_guts_logger << "hash\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_HASH);
}

{PERCENT}{COLON} {
	pp_lex_guts_logger << "hash\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_HASH);
}

{HASH}{HASH} {
	pp_lex_guts_logger << "hash_hash\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_HASH_HASH);
}

{PERCENT}{COLON}{PERCENT}{COLON} {
	pp_lex_guts_logger << "hash_hash\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_HASH_HASH);
}

{LEFT_PAR} {
	pp_lex_guts_logger << "left_par\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LEFT_PAR);
}

{RIGHT_PAR} {
	pp_lex_guts_logger << "right_par\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_RIGHT_PAR);
}

{SEMICOLON} {
	pp_lex_guts_logger << "semicolon\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SEMICOLON);
}

{COLON} {
	pp_lex_guts_logger << "colon\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_COLON);
}

{QMARK} {
	pp_lex_guts_logger << "qmark\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_QMARK);
}

{DOT} {
	pp_lex_guts_logger << "dot\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DOT);
}

{PLUS} {
	pp_lex_guts_logger << "plus\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PLUS);
}

{STAR} {
	pp_lex_guts_logger << "star\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_STAR);
}

{PERCENT} {
	pp_lex_guts_logger << "percent\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PERCENT);
}

{SLASH} {
	pp_lex_guts_logger << "slash\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SLASH);
}

{HAT} {
	pp_lex_guts_logger << "hat\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_HAT);
}

{x}{o}{r} {
	pp_lex_guts_logger << "hat\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_HAT);
}

{AMP} {
	pp_lex_guts_logger << "amp\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_AMP);
}

{b}{i}{t}{a}{n}{d} {
	pp_lex_guts_logger << "amp\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_AMP);
}

{VBAR} {
	pp_lex_guts_logger << "vbar\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VBAR);
}

{b}{i}{t}{o}{r} {
	pp_lex_guts_logger << "vbar\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_VBAR);
}

{TILDE} {
	pp_lex_guts_logger << "tilde\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TILDE);
}

{c}{o}{m}{p}{l} {
	pp_lex_guts_logger << "tilde\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_TILDE);
}

{EMARK} {
	pp_lex_guts_logger << "emark\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EMARK);
}

{n}{o}{t} {
	pp_lex_guts_logger << "emark\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_EMARK);
}

{EQ} {
	pp_lex_guts_logger << "eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EQ);
}

{LT} {
	pp_lex_guts_logger << "lt\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LT);
}

{GT} {
	pp_lex_guts_logger << "gt\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_GT);
}

{COMMA} {
	pp_lex_guts_logger << "comma\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_COMMA);
}

{MINUS} {
	pp_lex_guts_logger << "minus\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MINUS);
}

{COLON}{COLON} {
	pp_lex_guts_logger << "colon_colon\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_COLON_COLON);
}

{DOT}{STAR} {
	pp_lex_guts_logger << "dot_star\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DOT_STAR);
}

{PLUS}{EQ} {
	pp_lex_guts_logger << "plus_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PLUS_EQ);
}

{MINUS}{EQ} {
	pp_lex_guts_logger << "minus_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MINUS_EQ);
}

{STAR}{EQ} {
	pp_lex_guts_logger << "star_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_STAR_EQ);
}

{SLASH}{EQ} {
	pp_lex_guts_logger << "slash_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SLASH_EQ);
}

{PERCENT}{EQ} {
	pp_lex_guts_logger << "percent_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PERCENT_EQ);
}

{HAT}{EQ} {
	pp_lex_guts_logger << "hat_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_HAT_EQ);
}

{x}{o}{r}{_}{e}{q} {
	pp_lex_guts_logger << "hat_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_HAT_EQ);
}

{AMP}{EQ} {
	pp_lex_guts_logger << "amp_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_AMP_EQ);
}

{a}{n}{d}{_}{e}{q} {
	pp_lex_guts_logger << "amp_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_AMP_EQ);
}

{VBAR}{EQ} {
	pp_lex_guts_logger << "vbar_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VBAR_EQ);
}

{o}{r}{_}{e}{q} {
	pp_lex_guts_logger << "vbar_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_VBAR_EQ);
}

{LT}{LT} {
	pp_lex_guts_logger << "lt_lt\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LT_LT);
}

{GT}{GT} {
	pp_lex_guts_logger << "gt_gt\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_GT_GT);
}

{GT}{GT}{EQ} {
	pp_lex_guts_logger << "gt_gt_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_GT_GT_EQ);
}

{LT}{LT}{EQ} {
	pp_lex_guts_logger << "lt_lt_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LT_LT_EQ);
}

{EQ}{EQ} {
	pp_lex_guts_logger << "eq_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EQ_EQ);
}

{EMARK}{EQ} {
	pp_lex_guts_logger << "emark_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EMARK_EQ);
}

{n}{o}{t}{_}{e}{q} {
	pp_lex_guts_logger << "emark_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_EMARK_EQ);
}

{LT}{EQ} {
	pp_lex_guts_logger << "lt_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LT_EQ);
}

{GT}{EQ} {
	pp_lex_guts_logger << "gt_eq\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_GT_EQ);
}

{AMP}{AMP} {
	pp_lex_guts_logger << "amp_amp\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_AMP_AMP);
}

{a}{n}{d} {
	pp_lex_guts_logger << "amp_amp\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_AMP_AMP);
}

{VBAR}{VBAR} {
	pp_lex_guts_logger << "vbar_vbar\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VBAR_VBAR);
}

{o}{r} {
	pp_lex_guts_logger << "vbar_vbar\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create_alternative(LOCGET,pp_token::TOK_VBAR_VBAR);
}

{PLUS}{PLUS} {
	pp_lex_guts_logger << "plus_plus\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PLUS_PLUS);
}

{MINUS}{MINUS} {
	pp_lex_guts_logger << "minus_minus\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MINUS_MINUS);
}

{MINUS}{GT}{STAR} {
	pp_lex_guts_logger << "minus_gt_star\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MINUS_GT_STAR);
}

{MINUS}{GT} {
	pp_lex_guts_logger << "minus_gt\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MINUS_GT);
}

{DOT}{DOT}{DOT} {
	pp_lex_guts_logger << "dot_dot_dot\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DOT_DOT_DOT);
}

{a}{s}{m} {
	pp_lex_guts_logger << "asm\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ASM);
}


{a}{u}{t}{o} {
	pp_lex_guts_logger << "auto\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_AUTO);
}


{b}{o}{o}{l} {
	pp_lex_guts_logger << "bool\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BOOL);
}


{b}{r}{e}{a}{k} {
	pp_lex_guts_logger << "break\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BREAK);
}


{c}{a}{s}{e} {
	pp_lex_guts_logger << "case\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CASE);
}


{c}{a}{t}{c}{h} {
	pp_lex_guts_logger << "catch\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CATCH);
}


{c}{h}{a}{r} {
	pp_lex_guts_logger << "char\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CHAR);
}


{c}{l}{a}{s}{s} {
	pp_lex_guts_logger << "class\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CLASS);
}


{c}{o}{n}{s}{t} {
	pp_lex_guts_logger << "const\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CONST);
}

{c}{o}{n}{s}{t}{_}{c}{a}{s}{t} {
	pp_lex_guts_logger << "const_cast\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CONST_CAST);
}


{c}{o}{n}{t}{i}{n}{u}{e} {
	pp_lex_guts_logger << "continue\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_CONTINUE);
}


{d}{e}{f}{a}{u}{l}{t} {
	pp_lex_guts_logger << "default\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DEFAULT);
}


{d}{e}{l}{e}{t}{e} {
	pp_lex_guts_logger << "delete\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DELETE);
}


{d}{o} {
	pp_lex_guts_logger << "do\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DO);
}


{d}{o}{u}{b}{l}{e} {
	pp_lex_guts_logger << "double\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DOUBLE);
}


{d}{y}{n}{a}{m}{i}{c}{_}{c}{a}{s}{t} {
	pp_lex_guts_logger << "dynamic_cast\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DYNAMIC_CAST);
}


{e}{l}{s}{e} {
	pp_lex_guts_logger << "else\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ELSE);
}


{e}{n}{u}{m} {
	pp_lex_guts_logger << "enum\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ENUM);
}


{e}{x}{p}{l}{i}{c}{i}{t} {
	pp_lex_guts_logger << "explicit\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EXPLICIT);
}


{e}{x}{p}{o}{r}{t} {
	pp_lex_guts_logger << "export\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EXPORT);
}


{e}{x}{t}{e}{r}{n} {
	pp_lex_guts_logger << "extern\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_EXTERN);
}

{f}{l}{o}{a}{t} {
	pp_lex_guts_logger << "float\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_FLOAT);
}


{f}{o}{r} {
	pp_lex_guts_logger << "for\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_FOR);
}


{f}{r}{i}{e}{n}{d} {
	pp_lex_guts_logger << "friend\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_FRIEND);
}


{g}{o}{t}{o} {
	pp_lex_guts_logger << "goto\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_GOTO);
}


{i}{f} {
	pp_lex_guts_logger << "if\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IF);
}


{i}{n}{l}{i}{n}{e} {
	pp_lex_guts_logger << "inline\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_INLINE);
}


{i}{n}{t} {
	pp_lex_guts_logger << "int\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_INT);
}


{l}{o}{n}{g} {
	pp_lex_guts_logger << "long\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LONG);
}


{m}{u}{t}{a}{b}{l}{e} {
	pp_lex_guts_logger << "mutable\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_MUTABLE);
}


{n}{a}{m}{e}{s}{p}{a}{c}{e} {
	pp_lex_guts_logger << "namespace\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_NAMESPACE);
}


{n}{e}{w} {
	pp_lex_guts_logger << "new\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_NEW);
}


{o}{p}{e}{r}{a}{t}{o}{r} {
	pp_lex_guts_logger << "operator\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_OPERATOR);
}


{p}{r}{i}{v}{a}{t}{e} {
	pp_lex_guts_logger << "private\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PRIVATE);
}


{p}{r}{o}{t}{e}{c}{t}{e}{d} {
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PROTECTED);
	pp_lex_guts_logger << "protected\n" << msg::eolog;
}


{p}{u}{b}{l}{i}{c} {
	pp_lex_guts_logger << "public\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PUBLIC);
}


{r}{e}{g}{i}{s}{t}{e}{r} {
	pp_lex_guts_logger << "register\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_REGISTER);
}


{r}{e}{i}{n}{t}{e}{r}{p}{r}{e}{t}{_}{c}{a}{s}{t} {
	pp_lex_guts_logger << "reinterpret_cast\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_REINTERPRET_CAST);
}


{r}{e}{t}{u}{r}{n} {
	pp_lex_guts_logger << "return\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_RETURN);
}


{s}{h}{o}{r}{t} {
	pp_lex_guts_logger << "short\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SHORT);
}


{s}{i}{g}{n}{e}{d} {
	pp_lex_guts_logger << "signed\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SIGNED);
}


{s}{i}{z}{e}{o}{f} {
	pp_lex_guts_logger << "sizeof\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SIZEOF);
}


{s}{t}{a}{t}{i}{c} {
	pp_lex_guts_logger << "static\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_STATIC);
}


{s}{t}{a}{t}{i}{c}{_}{c}{a}{s}{t} {
	pp_lex_guts_logger << "static_cast\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_STATIC_CAST);
}


{s}{t}{r}{u}{c}{t} {
	pp_lex_guts_logger << "struct\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_STRUCT);
}


{s}{w}{i}{t}{c}{h} {
	pp_lex_guts_logger << "switch\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_SWITCH);
}


{t}{e}{m}{p}{l}{a}{t}{e} {
	pp_lex_guts_logger << "template\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TEMPLATE);
}


{t}{h}{i}{s} {
	pp_lex_guts_logger << "this\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_THIS);
}


{t}{h}{r}{o}{w} {
	pp_lex_guts_logger << "throw\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_THROW);
}


{t}{r}{y} {
	pp_lex_guts_logger << "try\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TRY);
}


{t}{y}{p}{e}{d}{e}{f} {
	pp_lex_guts_logger << "typedef\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TYPEDEF);
}


{t}{y}{p}{e}{i}{d} {
	pp_lex_guts_logger << "typeid\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TYPEID);
}


{t}{y}{p}{e}{n}{a}{m}{e} {
	pp_lex_guts_logger << "typename\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_TYPENAME);
}


{u}{n}{i}{o}{n} {
	pp_lex_guts_logger << "union\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_UNION);
}


{u}{n}{s}{i}{g}{n}{e}{d} {
	pp_lex_guts_logger << "unsigned\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_UNSIGNED);
}


{u}{s}{i}{n}{g} {
	pp_lex_guts_logger << "using\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_USING);
}


{v}{i}{r}{t}{u}{a}{l} {
	pp_lex_guts_logger << "virtual\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VIRTUAL);
}


{v}{o}{i}{d} {
	pp_lex_guts_logger << "void\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VOID);
}


{v}{o}{l}{a}{t}{i}{l}{e} {
	pp_lex_guts_logger << "volatile\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_VOLATILE);
}


{w}{c}{h}{a}{r}{_}{t} {
	pp_lex_guts_logger << "wchar\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_WCHAR);
}


{w}{h}{i}{l}{e} {
	pp_lex_guts_logger << "while\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_WHILE);
}

{f}{a}{l}{s}{e} {
	pp_lex_guts_logger << "false\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BOOL_LIT,token_value::create("false"));
}

{t}{r}{u}{e} {
	pp_lex_guts_logger << "false\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_BOOL_LIT,token_value::create("true"));
}

   /*
{i}{n}{c}{l}{u}{d}{e} {
	pp_lex_guts_logger << "include\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_INCLUDE);
}

{d}{e}{f}{i}{n}{e} {
	pp_lex_guts_logger << "define\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DEFINE);
}

{u}{n}{d}{e}{f} {
	pp_lex_guts_logger << "undef\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_UNDEF);
}

{l}{i}{n}{e} {
	pp_lex_guts_logger << "line\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LINE);
}

{p}{r}{a}{g}{m}{a} {
	pp_lex_guts_logger << "pragma\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PRAGMA);
}

{e}{r}{r}{o}{r} {
	pp_lex_guts_logger << "error\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ERROR);
}

{d}{e}{f}{i}{n}{e}{d} {
	pp_lex_guts_logger << "defined\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DEFINED);
}

{i}{f}{d}{e}{f} {
	pp_lex_guts_logger << "ifdef\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IFDEF);
}

{i}{f}{n}{d}{e}{f} {
	pp_lex_guts_logger << "ifndef\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IFNDEF);
}

{e}{l}{i}{f} {
	pp_lex_guts_logger << "elif\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ELIF);
}

{e}{n}{d}{i}{f} {
	pp_lex_guts_logger << "endif\n" << msg::eolog;

	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ENDIF);
}
   */

	/* pp number, can contain underscore */
({DIGIT}|{DOT}{DIGIT})({DIGIT}|{ALPHA}|{_}|({e}|{E})({PLUS}|{MINUS})|{DOT})* {
	pp_lex_guts_logger << "preprocessing number\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_NUMBER_LIT,EXTRACT_ORDINARY(yyleng));
}

	/* pp number with ucn */
({DIGIT}|{DOT}{DIGIT})({DIGIT}|{NONDIGIT}|({e}|{E})({PLUS}|{MINUS})|{DOT})* {
	pp_lex_guts_logger << "preprocessing number with ucn\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_NUMBER_LIT,EXTRACT_UCN_NUMBER(yyleng));
}

	/* pp number with bad ucn */
({DIGIT}|{DOT}{DIGIT})({DIGIT}|{NONDIGIT}|{UCN_BAD}|({e}|{E})({PLUS}|{MINUS})|{DOT})* {
	pp_lex_guts_logger << "preprocessing number with bad ucn\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_NUMBER_LIT,EXTRACT_BAD_NUMBER(yyleng));
}

	/* pp alphanumeric identifier */
({ALNUM}|{_})+ {
	pp_lex_guts_logger << "identifier without ucn\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_IDENT,EXTRACT_ORDINARY(yyleng));
}

	/* pp identifier with ucn */
{NONDIGIT}({DIGIT}|{NONDIGIT})* {
	pp_lex_guts_logger << "identifier with ucn\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_IDENT,EXTRACT_UCN_IDENTIFIER(yyleng));
}

	/* pp identifier ucn */
({NONDIGIT}|{UCN_BAD})({DIGIT}|{NONDIGIT}|{UCN_BAD})* {
	pp_lex_guts_logger << "identifier with bad ucn\n" << msg::eolog;

	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_IDENT,EXTRACT_BAD_IDENTIFIER(yyleng));
}

   /* start of recognition of directives */
<directive>({BLANK}|{LONG_COMMENT})*{HASH} {
	pp_lex_guts_logger << "hash in directive\n" << msg::eolog;

   BEGIN(directive_name);
   
   SKIP(yyleng - 1);
   /* save the location of the # */
	LOCSAVE;
   SKIP(1);

	return pp_token::create(LOCGET,pp_token::TOK_HASH);
}

   /* ## is longer than # and requires special rule */
<directive>({BLANK}|{LONG_COMMENT})*{HASH}{HASH} {
	pp_lex_guts_logger << "hash_hash in directive\n" << msg::eolog;

   BEGIN(INITIAL);
   /* return the characters */
   yyless(0);

}

   /* not a directive */
<directive>{ANY_CHAR} {
	pp_lex_guts_logger << "any char in directive\n" << msg::eolog;

   BEGIN(INITIAL);
   /* return the character */
   yyless(0);
}

   /* skip padding */
<directive_name>({BLANK}|{LONG_COMMENT})+ {
	pp_lex_guts_logger << "blanks and comments in directive name\n" << msg::eolog;

   ADVANCE;
   /* continue scanning */
}

<directive_name>{d}{e}{f}{i}{n}{e} {
	pp_lex_guts_logger << "define in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DEFINE);
}

<directive_name>{u}{n}{d}{e}{f} {
	pp_lex_guts_logger << "undef in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_UNDEF);
}

<directive_name>{p}{r}{a}{g}{m}{a} {
	pp_lex_guts_logger << "pragma in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_PRAGMA);
}

<directive_name>{e}{r}{r}{o}{r} {
	pp_lex_guts_logger << "error in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ERROR);
}

<directive_name>{d}{e}{f}{i}{n}{e}{d} {
	pp_lex_guts_logger << "defined in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_DEFINED);
}

<directive_name>{i}{f} {
	pp_lex_guts_logger << "if in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IF);
}

<directive_name>{i}{f}{d}{e}{f} {
	pp_lex_guts_logger << "ifdef in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IFDEF);
}

<directive_name>{i}{f}{n}{d}{e}{f} {
	pp_lex_guts_logger << "ifndef in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_IFNDEF);
}

<directive_name>{e}{l}{i}{f} {
	pp_lex_guts_logger << "elif in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ELIF);
}

<directive_name>{e}{l}{s}{e} {
	pp_lex_guts_logger << "else in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ELSE);
}

<directive_name>{e}{n}{d}{i}{f} {
	pp_lex_guts_logger << "endif in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_ENDIF);
}

<directive_name>{i}{n}{c}{l}{u}{d}{e} {
	pp_lex_guts_logger << "include in directive name\n" << msg::eolog;

   BEGIN(include);
	LOCSAVE;
   ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_INCLUDE);
}

<directive_name>{l}{i}{n}{e} {
	pp_lex_guts_logger << "line in directive name\n" << msg::eolog;

	LOCSAVE;
   ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_LINE);
}

   /* some other or longer identifier */
<directive_name>{NONDIGIT}({DIGIT}|{NONDIGIT})* {
	pp_lex_guts_logger << "other identifier in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
   /* return the identifier */
   yyless(0);
}

   /* something else than the above */
<directive_name>{ANY_CHAR} {
	pp_lex_guts_logger << "any char in directive name\n" << msg::eolog;

   BEGIN(INITIAL);
   /* return the character */
   yyless(0);
}

   /* skip spaces and comments to simplify processing of the following */
<include>({BLANK}|{LONG_COMMENT})+ {
	pp_lex_guts_logger << "blanks and comments in include\n" << msg::eolog;

	ADVANCE;
   /* continue scanning */
}

	/* angle bracketed name */
<include>{LT}{NOT_GT_NL}*{GT}({BLANK}|{LONG_COMMENT})*({SLASH}{SLASH}{LINE_COMMENT_CONTENT})?{NEW_LINE} {
	pp_lex_guts_logger << "angle bracketed name in include\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
	
   SKIP(1);
	/* everything between the '<' '>' is significant */
	ptr<token_value> tv(EXTRACT_UNTIL(character::ascii_gt));
   /* skip the '>' and everything but the newline */
	ulint len = yyleng - tv->content_get().size() - 2;
	SKIP(len);
  
   /* return only the newline */
	yyless(yyleng - 1);

	return pp_token::create(LOCGET,pp_token::TOK_INCL_HCHAR,tv);
}

	/* double quoted name */
<include>{DQUOTE}{NOT_DQUOTE_NL}*{DQUOTE}({BLANK}|{LONG_COMMENT})*({SLASH}{SLASH}{LINE_COMMENT_CONTENT})?{NEW_LINE} {
	pp_lex_guts_logger << "double quoted name in include\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
   
   SKIP(1);
	/* everything between the "" is significant, no support for escape sequences */
	ptr<token_value> tv(EXTRACT_UNTIL(character::ascii_dquote));
   /* skip the '"' and everything till but the newline */
	ulint len = yyleng - tv->content_get().size() - 2;
	SKIP(len);
  
   /* return only the newline */
	yyless(yyleng - 1);

	return pp_token::create(LOCGET,pp_token::TOK_INCL_QCHAR,tv);
}

	/* catches errors and third type include, which is handled by normal parser */
<include>{ANY_CHAR} {
	pp_lex_guts_logger << "any char in include\n" << msg::eolog;

   BEGIN(INITIAL);
	LOCSAVE;
   /* return the character */
	yyless(0);
	return pp_token::create(LOCGET,pp_token::TOK_INCL_SIG);
}

	/* special end of file class, not the flex <<EOF>> */
{EOF} {
	pp_lex_guts_logger << "eof\n" << msg::eolog;
   
	LOCSAVE;
	ADVANCE;
	return pp_token::create(LOCGET,pp_token::TOK_FILE_END);
}

	/* anything which is not a part of a token; " or ' will not appear here */
{NOT_EOF} {
	pp_lex_guts_logger << "other\n" << msg::eolog;
   
	LOCSAVE;
	return pp_token::create(LOCGET,pp_token::TOK_OTHER,EXTRACT_ORDINARY(yyleng));
}

%%

/* vim: set ft=lex : */
